Subject: RE: Host header issue

From: "Larry Masinter" <[email-masked]>
Date: Mon, 4 Oct 1999 17:00:33 PDT

> In the recent discussion on this topic I haven't seen a query on the
> text in section 14.23 "Host"  of RFC 2616 which says :
> 
>   "If the requested URI does not include an Internet host
>    name for the service being requested, then the Host header field MUST
>    be given with an empty value. "
>
> It is the "with an empty value" that confuses me - this seems to
> contradict what is written in section 5.1.2:
>   "The most common form of Request-URI is that used to identify a
>    resource on an origin server or gateway. In this case the absolute
>    path of the URI MUST be transmitted (see section 3.2.1, abs_path) as
>    the Request-URI, and the network location of the URI (authority) MUST
> 
>    be transmitted in a Host header field. "
> [...]
>        GET /pub/WWW/TheProject.html HTTP/1.1
>        Host: www.w3.org
> 
> If the text in 14.23 were followed you'd get
> 
>        GET /pub/WWW/TheProject.html HTTP/1.1
>        Host:
> 
> which would surely be wrong. My understanding from the spec and this
> discussion thread is that it should be possible to identify the host,
> whether by a relative URI plus valid Host value or by an absolute URI
> (plus redundant Host header, which I suppose you could legitimately
> allow to have an empty value in this case?)
> 
> Is this one for the errata?

Well, it probably deserves a clarification. What I vaguely recall
is that we were trying to leave room for non-HTTP based proxying,
e.g., where you asked your proxy

       GET news:comp.infosystems.www HTTP/1.1
       Host:

Clearly not the interpretation you read into it. Does anyone else
recall what we really meant?

---

From: "Josh Cohen (Exchange)" <[email-masked]>
Date: Mon, 4 Oct 1999 22:34:30 -0700

I cant say if this is consensus, but my take was that
you only use the host header when you are proxying/requesting
http urls.  This is because the Host: header and value
only make sense for HTTP URLS.

The main point of adding the host header was to address
the "shortcoming" of http urls that didnt indicate
a host portion.

> -----Original Message-----
> From: Larry Masinter [mailto:[email-masked]]
> Sent: Monday, October 04, 1999 5:01 PM
> To: Geoff Macartney
> Cc: [email-masked]
> Subject: RE: Host header issue
> 
>